/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package p4uclient;

import java.io.*;
import java.net.Socket;

/**
 * クライアントセッションを管理
 * @author tondol
 */
public class ClientManager {
    private Socket         socket = null;
    private BufferedReader reader = null;
    private PrintWriter    writer = null;
    String host = null;
    int listen = 0;
    
    public ClientManager() throws IOException {
        socket = new Socket(MainApp.option.host, MainApp.option.port);
        // 入力ストリームの文字コードを自動認識させる
        reader = new BufferedReader(new InputStreamReader(
                socket.getInputStream(), "JISAUTODETECT"));
        writer = new PrintWriter(socket.getOutputStream());
        // サーバーから見たホスト名を取得
        host   = reader.readLine();
        listen = MainApp.option.listen;
    }
    
    public void close() throws IOException {
        if (writer != null) writer.close();
        if (socket != null) socket.close();
    }
    
    public void addItem(FileItem item) throws IOException {
        sendMessage("ADD " + item);
        MainApp.window.putMessage(recvMessage());
    }
    
    public void delItem(FileItem item) throws IOException {
        sendMessage("DEL " + item);
        MainApp.window.putMessage(recvMessage());
    }
    
    public void getList(String word) throws IOException {
        sendMessage("LS " + word);
        int size = Integer.parseInt(recvMessage());
        for(int i=0;i<size;i++){
            
        }
    }
    
    public void getInfo(FileItem item) throws IOException {
        sendMessage("INFO " + item.hash);
        int size = Integer.parseInt(recvMessage());
        for(int i=0;i<size;i++){
            
        }
    }
    
    public String recvMessage() throws IOException {
        return reader.readLine();
    }
    
    public void sendMessage(String msg) {
        writer.println(msg);
        writer.flush();
    }
}
