/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package p4uclient;

import java.util.ArrayList;
import javax.swing.table.AbstractTableModel;

/**
 * FileInfoをJTableで使うためのモデル
 * @author tondol
 */
public class FileTableModel extends AbstractTableModel {
    ArrayList<FileItem> items = new ArrayList<FileItem>();

    public FileItem getItem(int index) {
        return items.get(index);
    }
    
    public void setItems(ArrayList<FileItem> items) {
        this.items = items;
        fireTableDataChanged();
    }
    
    public void addItem(FileItem item) {
        items.add(item);
        int index = items.indexOf(item);
        fireTableRowsInserted(index, index);
    }
    
    public void deleteItem(FileItem item) {
        int index = items.indexOf(item);
        items.remove(item);
        fireTableRowsInserted(index, index);
    }
    
    public int getRowCount() {
        return items.size();
    }

    public int getColumnCount() {
        return 3;
    }
    
    @Override public String getColumnName(int column) {
        String values[] = { "ファイル名", "サイズ", "ハッシュ" };
        return values[column];
    }

    public Object getValueAt(int rowIndex, int columnIndex) {
        switch (columnIndex) {
            case 0: return items.get(rowIndex).name;
            case 1: return items.get(rowIndex).size;
            case 2: return items.get(rowIndex).hash;
            default: return null;
        }
    }
}
